--MANUAL-POSITION-CONFIG--------------------------------------------------------------------------------------------
RHRuneX1 = -103										-- X coordinate for the the 1st rune
RHRuneX2 = -72										-- X coordinate for the the 2nd rune
RHRuneX3 = -25										-- X coordinate for the the 3rd rune
RHRuneX4 = 25										-- X coordinate for the the 3th rune
RHRuneX5 = 72										-- X coordinate for the the 5th rune
RHRuneX6 = 103										-- X coordinate for the the 6th rune
RHRuneY1 = 23										-- Y coordinate for the the 1st rune
RHRuneY2 = 61										-- Y coordinate for the the 2nd rune
RHRuneY3 = 80										-- Y coordinate for the the 3rd rune
RHRuneY4 = 80										-- Y coordinate for the the 4th rune
RHRuneY5 = 61										-- Y coordinate for the the 5th rune
RHRuneY6 = 23 										-- Y coordinate for the the 6th rune
--------------------------------------------------------------------------------------------------------------------

SLASH_RUNEHUD1, SLASH_RUNEHUD2 = '/runehud', '/rh';
local function handler(msg, editbox)
local command, rest = msg:match("^(%S*)%s*(.-)$")
	local classLocal, class = UnitClass("player")
	if class == "DEATHKNIGHT" then
		if command:lower() == 'scale' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) > 0 then
					RHScale = tonumber(rest)
					RuneFrame:SetScale(RHScale)
				else
					print("RuneHUD: You need to use a valid value for the scale");
				end
			else
				print("RuneHUD: You need to use a valid value for the scale");
			end
		elseif command:lower() == 'nocombatalpha' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHNoCombatAlpha = tonumber(rest)			
					if InCombatLockdown() == false then
						RuneFrame:SetAlpha(RHNoCombatAlpha)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command:lower() == 'combatalpha' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHCombatAlpha = tonumber(rest)
					if InCombatLockdown() == true then
						RuneFrame:SetAlpha(RHCombatAlpha)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command:lower() == 'barenable' then
			if rest:lower() == "true" or "false" then 
				if rest:lower() == "false" then
					RHBarEnable = false
					RuneHUDFrame:UnregisterEvent("UNIT_POWER_FREQUENT")
					RuneHUDBar:Hide()
				else
					RHBarEnable = true
					RuneHUDFrame:RegisterUnitEvent("UNIT_POWER_FREQUENT","player")
					if InCombatLockdown() == true then
						RuneHUDBar:Show()
					elseif RHBarNoCombat == true then
						RuneHUDBar:Show()
					end
				end
			else
				print("RuneHUD: You need to use a either true or false");
			end
		elseif command:lower() == 'barnocombat' then
			if rest:lower() == "true" or "false" then 
				if rest:lower() == "false" then
						RHBarNoCombat = false
						if InCombatLockdown() == false and class == "DEATHKNIGHT"then
							RuneHUDBar:Hide()
						end
				else
					RHBarNoCombat = true
					if class == "DEATHKNIGHT" then
						RuneHUDBar:Show()
					end
				end
			else
				print("RuneHUD: You need to use a either true or false");
			end
		elseif command:lower() == 'barwidth' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHBarWidth = tonumber(rest)
					RuneHUDBar:SetWidth(RHBarWidth)
					RuneHUDBackground:SetWidth(RHBarWidth + 2)
				else
					print("RuneHUD: You need to use a valid value for the width");
				end
			else
				print("RuneHUD: You need to use a valid value for the width");
			end
		elseif command:lower() == 'barheight' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHBarHeight = tonumber(rest)
					RuneHUDBar:SetHeight(RHBarHeight)
					RuneHUDBackground:SetHeight(RHBarHeight + 2)
					local fontSize = RHBarHeight-RHBarHeight*0,1
					RunicPowerValue:SetFont("Fonts\\FRIZQT__.TTF", fontSize, "OUTLINE")
				else
					print("RuneHUD: You need to use a valid value for the height");
				end
			else
				print("RuneHUD: You need to use a valid value for the height");
			end
		elseif command:lower() == 'baryposition' then
			if tonumber(rest) ~= nil then 
				RHBarYPosition = tonumber(rest)
				print(RHBarYPosition)
				print(RHBarXPosition)
				RuneHUDBar:SetPoint("CENTER", UIParent, "CENTER", RHBarXPosition, RHBarYPosition)
			else
				print("RuneHUD: You need to use a valid value for the vertical position");
			end
		elseif command:lower() == 'barnocombatalpha' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHBarNoCombatAlpha = tonumber(rest)			
					if InCombatLockdown() == false then
						RuneHUDBar:SetAlpha(RHBarNoCombatAlpha)
						RuneHUDBarDepleted:SetAlpha(RHBarNoCombatAlpha)
						RuneHUDBackground:SetAlpha(RHBarNoCombatAlpha)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command:lower() == 'barcombatalpha' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHBarCombatAlpha = tonumber(rest)			
					if InCombatLockdown() == true then
						RuneHUDBar:SetAlpha(RHBarCombatAlpha)
						RuneHUDBarDepleted:SetAlpha(RHBarCombatAlpha)
						RuneHUDBackground:SetAlpha(RHBarCombatAlpha)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command:lower() == 'reset' then
			RHScale = 1.2
			RHYPos = 0
			RHNoCombatAlpha = 0.1
			RHCombatAlpha = 1
			RHBarCombatAlpha = 1
			RHBarNoCombatAlpha = 1
			RHBarWidth = 250
			RHBarHeight = 15
			RHBarYPosition = -145
			RHBarXPosition = 0
			RHBarEnable = true
			RHBarNoCombat = false
			RHRuneX1 = -103
			RHRuneX2 = -72
			RHRuneX3 = -25
			RHRuneX4 = 25
			RHRuneX5 = 72
			RHRuneX6 = 103
			RHRuneY1 = 23
			RHRuneY2 = 61
			RHRuneY3 = 80
			RHRuneY4 = 80
			RHRuneY5 = 61
			RHRuneY6 = 23
			RuneFrame.Rune1:SetPoint("CENTER", UIParent, "CENTER", RHRuneX1, RHYPos + RHRuneY1)
			RuneFrame.Rune2:SetPoint("CENTER", UIParent, "CENTER", RHRuneX2, RHYPos + RHRuneY2)
			RuneFrame.Rune3:SetPoint("CENTER", UIParent, "CENTER", RHRuneX3, RHYPos + RHRuneY3)
			RuneFrame.Rune4:SetPoint("CENTER", UIParent, "CENTER", RHRuneX4, RHYPos + RHRuneY4)
			RuneFrame.Rune5:SetPoint("CENTER", UIParent, "CENTER", RHRuneX5, RHYPos + RHRuneY5)
			RuneFrame.Rune6:SetPoint("CENTER", UIParent, "CENTER", RHRuneX6, RHYPos + RHRuneY6)
			
			if InCombatLockdown() == false then
				RuneHUDBar:Hide()
			end

			
		else
			print("RuneHUD: The available slash commands are:");
			print("RuneHUD: '/rh Scale <scale>' for scaling");
			print("RuneHUD: '/rh NoCombatAlpha <alpha>' for the alpha of the runes out of combat");
			print("RuneHUD: '/rh CombatAlpha <alpha>' for the alpha of the runes in combat");
			print("RuneHUD: '/rh BarEnable <true/false>' to enable or disable the runic power bar");
			print("RuneHUD: '/rh BarNoCombat <true/false>' to enable or disable the runic power bar out of combat");
			print("RuneHUD: '/rh BarWidth <width>' for the width of the runic power bar");
			print("RuneHUD: '/rh BarHeight <width>' for the height of the runic power bar");
			print("RuneHUD: '/rh BarYPosition <Y-pos>' the Y-coordinate for the vertical position of the runic power bar");
			print("RuneHUD: '/rh BarNoCombatAlpha <alpha>' for the alpha of the runic power bar out of combat");
			print("RuneHUD: '/rh BarCombatAlpha <alpha>' for the alpha of the runic power bar in combat");
			print("RuneHUD: '/rh reset' to reset to standard values for all settings");
		end
	end
end
SlashCmdList["RUNEHUD"] = handler;




local function RuneHUD_OnEvent(self, event, ...)
local classLocal, class = UnitClass("player")
	if class == "DEATHKNIGHT" then
		if event == "UNIT_POWER_FREQUENT" then
			if RHBarEnable == true then
				RuneHUDBar:SetValue(UnitPower("player"))
				RunicPowerValue:SetText(UnitPower("player"))
			else
				RuneHUDFrame:UnregisterEvent("UNIT_POWER_FREQUENT")
			end
		elseif event == "PLAYER_REGEN_ENABLED" and UnitInVehicleControlSeat("player") == false and UnitHasVehicleUI("player") == false then
			if RHBarEnable == true and 	RHBarNoCombat == true then
				RuneHUDBar:SetFrameStrata("LOW")
				RuneHUDBar:SetAlpha(RHBarNoCombatAlpha)
				RuneHUDBarDepleted:SetAlpha(RHBarNoCombatAlpha)
				RuneHUDBackground:SetAlpha(RHBarNoCombatAlpha)
			elseif RHBarNoCombat == false then
				RuneHUDBar:Hide()
			end
			RuneFrame:SetAlpha(RHNoCombatAlpha)
			RuneFrame:SetFrameStrata("LOW")
		elseif event == "PLAYER_REGEN_DISABLED" and UnitInVehicleControlSeat("player") == false and UnitHasVehicleUI("player") == false then
			if RHBarEnable == true then
				RuneHUDBar:Show()
				RuneHUDBar:SetAlpha(RHBarCombatAlpha)
				RuneHUDBarDepleted:SetAlpha(RHBarCombatAlpha)
				RuneHUDBackground:SetAlpha(RHBarCombatAlpha)
				RuneHUDBar:SetFrameStrata("MEDIUM")
			end
			RuneFrame:SetAlpha(RHCombatAlpha)
			RuneFrame:SetFrameStrata("MEDIUM")	
		elseif event == "UNIT_ENTERING_VEHICLE" and UnitInVehicleControlSeat("player") == true and  UnitHasVehicleUI("player") == true then
			RuneFrame:Hide()
			RuneHUDBar:Hide()
		elseif event == "UNIT_EXITING_VEHICLE" then
			RuneFrame:Show()
			if InCombatLockdown() == true then
				RuneFrame:SetAlpha(RHCombatAlpha)
				if RHBarEnable == true then
					RuneHUDBar:Show()
					RuneHUDBar:SetAlpha(RHBarCombatAlpha)
					RuneHUDBarDepleted:SetAlpha(RHBarCombatAlpha)
					RuneHUDBackground:SetAlpha(RHBarCombatAlpha)
				else
					RuneHUDBar:Hide()
				end
			else
				RuneFrame:SetAlpha(RHNoCombatAlpha)
				if RHBarEnable == true and RHBarNoCombat == true then
					RuneHUDBar:Show()
					RuneHUDBar:SetAlpha(RHBarNoCombatAlpha)
					RuneHUDBarDepleted:SetAlpha(RHBarNoCombatAlpha)
					RuneHUDBackground:SetAlpha(RHBarNoCombatAlpha)
				else
					RuneHUDBar:Hide()
				end
			end	
		elseif event == "PLAYER_ENTERING_WORLD" then
			if UnitInVehicleControlSeat("player") == false and UnitHasVehicleUI("player") == false then
				if InCombatLockdown() == false then
					if RHBarEnable == true and RHBarNoCombat == false then
						RuneHUDBar:Hide()
					elseif RHBarEnable == true and RHBarNoCombat == true then
						RuneHUDBar:Show()
						RuneHUDBar:SetAlpha(RHBarNoCombatAlpha)
						RuneHUDBarDepleted:SetAlpha(RHBarNoCombatAlpha)
						RuneHUDBackground:SetAlpha(RHBarNoCombatAlpha)
						RuneHUDBar:SetFrameStrata("LOW")
						if UnitName("player") == ("Flundrine" or "Flundran") and IsAddOnLoaded("SharedMedia") then
							RuneHUDBar:SetStatusBarTexture("Interface\\AddOns\\SharedMedia\\statusbar\\Flat")
						else
							RuneHUDBar:SetStatusBarTexture("Interface\\AddOns\\RuneHUD\\StatusBar")
						end
					else
						RuneHUDBar:Hide()
					end
					RuneFrame:SetAlpha(RHNoCombatAlpha)	
					RuneFrame:SetFrameStrata("LOW")	
				else
					if RHBarEnable == true then
						RuneHUDBar:Show()
						RuneHUDBar:SetFrameStrata("MEDIUM")
						RuneHUDBar:SetAlpha(RHBarCombatAlpha)
						RuneHUDBarDepleted:SetAlpha(RHBarCombatAlpha)
						RuneHUDBackground:SetAlpha(RHBarCombatAlpha)
						if UnitName("player") == ("Flundrine" or "Flundran") and IsAddOnLoaded("SharedMedia") then
							RuneHUDBar:SetStatusBarTexture("Interface\\AddOns\\SharedMedia\\statusbar\\Flat")
						else
							RuneHUDBar:SetStatusBarTexture("Interface\\AddOns\\RuneHUD\\StatusBar")
						end
					else
						RuneHUDBar:Hide()
					end
					RuneFrame:SetAlpha(RHCombatAlpha)
					RuneFrame:SetFrameStrata("MEDIUM")
				end
			else
				RuneFrame:Hide()
			end
		elseif event == "ADDON_LOADED" then
			if type(RHScale) ~= "number" then
				RHScale = 1.2
			end
			if type(RHYPos) ~= "number" then
				RHYPos = 0
			end
			if type(RHCombatAlpha) ~= "number" then
				RHCombatAlpha = 1
			end
			if type(RHNoCombatAlpha) ~= "number" then
				RHNoCombatAlpha = 0.1
			end
			if type(RHBarEnable) ~= "boolean" then
				RHBarEnable = true
			end
			if type(RHBarNoCombat) ~= "boolean" then
				RHBarNoCombat = false
			end
			if type(RHBarCombatAlpha) ~= "number" then
				RHBarCombatAlpha = 1
			end
			if type(RHBarNoCombatAlpha) ~= "number" then
				RHBarNoCombatAlpha = 1
			end
			if type(RHBarHeight) ~= "number" then
				RHBarHeight = 15
			end
			if type(RHBarWidth) ~= "number" then
				RHBarWidth = 250
			end
			if type(RHBarYPosition) ~= "number" then
				RHBarYPosition = -145
			end
			if type(RHBarXPosition) ~= "number" then
				RHBarXPosition = 0
			end
			if type(RHRuneX1) ~= "number" then
				RHRuneX1 = -103
				RHRuneX2 = -72
				RHRuneX3 = -25
				RHRuneX4 = 25
				RHRuneX5 = 72
				RHRuneX6 = 103
				RHRuneY1 = 23
				RHRuneY2 = 61
				RHRuneY3 = 80
				RHRuneY4 = 80
				RHRuneY5 = 61
				RHRuneY6 = 23
			end				
			
			RuneFrame.Rune1:ClearAllPoints()
			RuneFrame.Rune2:ClearAllPoints()
			RuneFrame.Rune3:ClearAllPoints()
			RuneFrame.Rune4:ClearAllPoints()
			RuneFrame.Rune5:ClearAllPoints()
			RuneFrame.Rune6:ClearAllPoints()

			RuneFrame.Rune1:SetPoint("CENTER", UIParent, "CENTER", RHRuneX1, RHYPos + RHRuneY1)
			RuneFrame.Rune2:SetPoint("CENTER", UIParent, "CENTER", RHRuneX2, RHYPos + RHRuneY2)
			RuneFrame.Rune3:SetPoint("CENTER", UIParent, "CENTER", RHRuneX3, RHYPos + RHRuneY3)
			RuneFrame.Rune4:SetPoint("CENTER", UIParent, "CENTER", RHRuneX4, RHYPos + RHRuneY4)
			RuneFrame.Rune5:SetPoint("CENTER", UIParent, "CENTER", RHRuneX5, RHYPos + RHRuneY5)
			RuneFrame.Rune6:SetPoint("CENTER", UIParent, "CENTER", RHRuneX6, RHYPos + RHRuneY6)

			RuneFrame.Rune1:EnableMouse(false)
			RuneFrame.Rune2:EnableMouse(false)
			RuneFrame.Rune3:EnableMouse(false)
			RuneFrame.Rune4:EnableMouse(false)
			RuneFrame.Rune5:EnableMouse(false)
			RuneFrame.Rune6:EnableMouse(false)
			
			RuneFrame:SetScale(RHScale)
	
			CreateFrame("StatusBar", "RuneHUDBar", UIParent)
			RuneHUDBar:CreateFontString("RunicPowerValue", "OVERLAY")
			RuneHUDBar:CreateTexture("RuneHUDBarDepleted", "BORDER")
			RuneHUDBar:CreateTexture("RuneHUDBackground", "BACKGROUND")
			RuneHUDBar:SetPoint("CENTER", UIParent, "CENTER", RHBarXPosition, RHBarYPosition)
			RuneHUDBar:SetWidth(RHBarWidth)
			RuneHUDBar:SetHeight(RHBarHeight)
			if UnitName("player") == ("Flundrine" or "Flundran") and IsAddOnLoaded("SharedMedia") then
				RuneHUDBar:SetStatusBarTexture("Interface\\AddOns\\SharedMedia\\statusbar\\Flat")
			else
				RuneHUDBar:SetStatusBarTexture("Interface\\AddOns\\RuneHUD\\StatusBar")
			end
			RuneHUDBar:GetStatusBarTexture():SetHorizTile(false)
			RuneHUDBar:GetStatusBarTexture():SetVertTile(false)
			RuneHUDBar:SetStatusBarColor(0, 0.8, 1)
			RuneHUDBar:SetMinMaxValues(0, UnitPowerMax("player", SPELL_POWER_RUNIC_POWER)) 
			RuneHUDBar:SetValue(UnitPower("player"))

			RuneHUDBarDepleted:SetTexture("Interface\\AddOns\\RuneHUD\\Background")
			RuneHUDBarDepleted:SetAllPoints(true)
			RuneHUDBarDepleted:SetVertexColor(0.2, 0.2, 0.2)
	
			RuneHUDBackground:SetPoint("CENTER", RuneHUDBar, "CENTER", 0, 0)
			RuneHUDBackground:SetWidth(RHBarWidth + 2)
			RuneHUDBackground:SetHeight(RHBarHeight + 2)
			RuneHUDBackground:SetTexture("Interface\\AddOns\\RuneHUD\\Background")
			RuneHUDBackground:SetVertexColor(0, 0, 0)
			
			RunicPowerValue:SetPoint("CENTER", RuneHUDBar, "CENTER", 0, 0)
			local fontSize = RHBarHeight-RHBarHeight*0,1
			if UnitName("player") == ("Flundrine" or "Flundran") and IsAddOnLoaded("SharedMedia") then
				RunicPowerValue:SetFont("Interface\\Addons\\SharedMedia_MyMedia\\font\\Roboto-Bold.ttf", 15, "OUTLINE")
			else
				RunicPowerValue:SetFont("Fonts\\ARIALN.ttf", fontSize, "OUTLINE")
			end
			RunicPowerValue:SetJustifyH("CENTER")
			RunicPowerValue:SetJustifyV("MIDDLE")
			RunicPowerValue:SetTextColor(1, 1, 1)
			RunicPowerValue:SetText(UnitPower("player"))
		elseif event == "UNIT_MAXPOWER" then
			RuneHUDBar:SetMinMaxValues(0, UnitPowerMax("player", SPELL_POWER_RUNIC_POWER))
		end
	else
		RuneHUDFrame:UnregisterEvent("PLAYER_REGEN_DISABLED")
		RuneHUDFrame:UnregisterEvent("PLAYER_REGEN_ENABLED")
		RuneHUDFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
		RuneHUDFrame:UnregisterEvent("ADDON_LOADED")
		RuneHUDFrame:UnregisterEvent("UNIT_MAXPOWER")
		RuneHUDFrame:UnregisterEvent("UNIT_EXITING_VEHICLE")
		RuneHUDFrame:UnregisterEvent("UNIT_ENTERING_VEHICLE")
		RuneHUDFrame:UnregisterEvent("UNIT_POWER_FREQUENT")
	end
end

local f = CreateFrame("Frame","RuneHUDFrame",UIParent)
f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("PLAYER_REGEN_ENABLED")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("UNIT_MAXPOWER")
f:RegisterUnitEvent("UNIT_EXITING_VEHICLE","player")
f:RegisterUnitEvent("UNIT_ENTERING_VEHICLE","player")
f:RegisterUnitEvent("UNIT_POWER_FREQUENT","player")
f:SetScript("OnEvent", RuneHUD_OnEvent)
RuneHUDFrame.unit = "player"
RuneFrame:SetParent(_G["RuneHUDFrame"])